# ObjectDescriptor type

class pyasn1.type.useful.ObjectDescriptor(value=NoValue(), tagSet=TagSet(), subtypeSpec=ConstraintsIntersection(), encoding='us-ascii')

  Creates ObjectDescriptor schema or value object.

  ObjectDescriptor class is based on `SimpleAsn1Type`, its objects are immutable and duck-type `bytes`. When used in octet-stream context, ObjectDescriptor type assumes “iso-8859-1” encoding.

  Keyword Arguments:

    - value (`str`, `bytes` or ObjectDescriptor object) – `str`, alternatively `bytes` representing octet-stream of serialised unicode string (note encoding parameter) or ObjectDescriptor class instance. If value is not given, schema object will be created.

    - tagSet (`TagSet`) – Object representing non-default ASN.1 tag(s)

    - subtypeSpec (`ConstraintsIntersection`) – Object representing non-default ASN.1 subtype constraint(s). Constraints verification for ObjectDescriptor type occurs automatically on object instantiation.

    - encoding (`str`) – Unicode codec ID to encode/decode `str` the payload when ObjectDescriptor object is used in octet-stream context.

  Raises:

    ValueConstraintError, PyAsn1Error – On constraint violation or bad initializer.

  Note

  The ObjectDescriptor type models a character string that can accompany the ObjectIdentifier type to serve as a human-friendly annotation for an OBJECT IDENTIFIER.

  clone(self, value=NoValue(), tagSet=TagSet(), subtypeSpec=ConstraintsIntersection(), encoding='us-ascii')

    Create a modified version of ObjectDescriptor schema or value object.

    The clone() method accepts the same set arguments as ObjectDescriptor class takes on instantiation except that all arguments of the clone() method are optional.

    Whatever arguments are supplied, they are used to create a copy of self taking precedence over the ones used to instantiate self.

    Note

    Due to the immutable nature of the ObjectDescriptor object, if no arguments are supplied, no new ObjectDescriptor object will be created and self will be returned instead.

  subtype(self, value=NoValue(), implicitTag=TagSet(), explicitTag=TagSet(), subtypeSpec=ConstraintsIntersection(), encoding='us-ascii')

    Create a specialization of ObjectDescriptor schema or value object.

    The subtype relationship between ASN.1 types has no correlation with subtype relationship between Python types. ASN.1 type is mainly identified by its tag(s) (`TagSet`) and value range constraints (`ConstraintsIntersection`). These ASN.1 type properties are implemented as ObjectDescriptor attributes.

    The subtype() method accepts the same set arguments as ObjectDescriptor class takes on instantiation except that all parameters of the subtype() method are optional.

    With the exception of the arguments described below, the rest of supplied arguments they are used to create a copy of self taking precedence over the ones used to instantiate self.

    The following arguments to subtype() create a ASN.1 subtype out of ObjectDescriptor type:

    Other Parameters:

      - implicitTag (`Tag`) – Implicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - explicitTag (`Tag`) – Explicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - subtypeSpec (`ConstraintsIntersection`) – Add ASN.1 constraints object to one of the self’s, then use the result as new object’s ASN.1 constraints.

    Returns:

      new instance of ObjectDescriptor schema or value object

    Note

    Due to the immutable nature of the ObjectDescriptor object, if no arguments are supplied, no new ObjectDescriptor object will be created and self will be returned instead.

  tagSet = <TagSet object, tags 0:0:7>

    Default `TagSet` object for ObjectDescriptor objects

  isSameTypeWith(other, matchTags=True, matchConstraints=True)

    Examine ObjectDescriptor type for equality with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters:

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns:

      `bool` – `True` if other is ObjectDescriptor type, `False` otherwise.

  isSuperTypeOf(other, matchTags=True, matchConstraints=True)

    Examine ObjectDescriptor type for subtype relationship with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters:

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns:

      `bool` – `True` if other is a subtype of ObjectDescriptor type, `False` otherwise.

  property isValue

    Indicate that ObjectDescriptor object represents ASN.1 value.

    If isValue is `False` then this object represents just ASN.1 schema.

    If isValue is `True` then, in addition to its ASN.1 schema features, this object can also be used like a Python built-in object (e.g. `int`, `str`, `dict` etc.).

    Returns:

      `bool` – `False` if object represents just ASN.1 schema. `True` if object represents ASN.1 schema and can be used as a normal value.

    Note

    There is an important distinction between PyASN1 schema and value objects. The PyASN1 schema objects can only participate in ASN.1 schema-related operations (e.g. defining or testing the structure of the data). Most obvious uses of ASN.1 schema is to guide serialisation codecs whilst encoding/decoding serialised ASN.1 contents.

    The PyASN1 value objects can additionally participate in many operations involving regular Python objects (e.g. arithmetic, comprehension etc).